<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.bitset;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.ByteArrayInputStream;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.ByteArrayOutputStream;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.DataInput;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.io.DataInputStream;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.io.DataOutput;<a name="line.40"></a>
<FONT color="green">041</FONT>    import java.io.DataOutputStream;<a name="line.41"></a>
<FONT color="green">042</FONT>    import java.io.IOException;<a name="line.42"></a>
<FONT color="green">043</FONT>    import java.io.InputStream;<a name="line.43"></a>
<FONT color="green">044</FONT>    import java.io.OutputStream;<a name="line.44"></a>
<FONT color="green">045</FONT>    import java.util.BitSet;<a name="line.45"></a>
<FONT color="green">046</FONT>    import java.util.Random;<a name="line.46"></a>
<FONT color="green">047</FONT>    import java.util.zip.ZipEntry;<a name="line.47"></a>
<FONT color="green">048</FONT>    import java.util.zip.ZipInputStream;<a name="line.48"></a>
<FONT color="green">049</FONT>    import java.util.zip.ZipOutputStream;<a name="line.49"></a>
<FONT color="green">050</FONT>    <a name="line.50"></a>
<FONT color="green">051</FONT>    import ch.javasoft.util.numeric.IntegerUtil;<a name="line.51"></a>
<FONT color="green">052</FONT>    <a name="line.52"></a>
<FONT color="green">053</FONT>    public class SimpleLongBitSet implements GenericBitSet&lt;SimpleLongBitSet&gt; {<a name="line.53"></a>
<FONT color="green">054</FONT>            <a name="line.54"></a>
<FONT color="green">055</FONT>        public static final BitSetFactory&lt;SimpleLongBitSet&gt; FACTORY = new BitSetFactory&lt;SimpleLongBitSet&gt;() {<a name="line.55"></a>
<FONT color="green">056</FONT>            public SimpleLongBitSet createBitSet() {<a name="line.56"></a>
<FONT color="green">057</FONT>                return new SimpleLongBitSet();<a name="line.57"></a>
<FONT color="green">058</FONT>            }<a name="line.58"></a>
<FONT color="green">059</FONT>            public SimpleLongBitSet createBitSetBeingEqualForSameInstanceOnly() {<a name="line.59"></a>
<FONT color="green">060</FONT>                return new SimpleLongBitSet() {<a name="line.60"></a>
<FONT color="green">061</FONT>                                    @Override<a name="line.61"></a>
<FONT color="green">062</FONT>                    public boolean equals(Object obj) {<a name="line.62"></a>
<FONT color="green">063</FONT>                        return this == obj;<a name="line.63"></a>
<FONT color="green">064</FONT>                    }<a name="line.64"></a>
<FONT color="green">065</FONT>                                    @Override<a name="line.65"></a>
<FONT color="green">066</FONT>                                    public int hashCode() {<a name="line.66"></a>
<FONT color="green">067</FONT>                                            return hashCodeObj();<a name="line.67"></a>
<FONT color="green">068</FONT>                                    }<a name="line.68"></a>
<FONT color="green">069</FONT>                };<a name="line.69"></a>
<FONT color="green">070</FONT>            }<a name="line.70"></a>
<FONT color="green">071</FONT>            public SimpleLongBitSet[] createArray(int size) {<a name="line.71"></a>
<FONT color="green">072</FONT>                return new SimpleLongBitSet[size];<a name="line.72"></a>
<FONT color="green">073</FONT>            }<a name="line.73"></a>
<FONT color="green">074</FONT>            public SimpleLongBitSet createBitSet(BitSet bits) {<a name="line.74"></a>
<FONT color="green">075</FONT>                return new SimpleLongBitSet(bits);<a name="line.75"></a>
<FONT color="green">076</FONT>            }<a name="line.76"></a>
<FONT color="green">077</FONT>        };<a name="line.77"></a>
<FONT color="green">078</FONT>    <a name="line.78"></a>
<FONT color="green">079</FONT>        public static final BitSetOps&lt;SimpleLongBitSet&gt; OPS = new BitSetOps&lt;SimpleLongBitSet&gt;() {<a name="line.79"></a>
<FONT color="green">080</FONT>            public SimpleLongBitSet and(SimpleLongBitSet opA, SimpleLongBitSet opB) {<a name="line.80"></a>
<FONT color="green">081</FONT>                return SimpleLongBitSet.getAnd(opA, opB);<a name="line.81"></a>
<FONT color="green">082</FONT>            }<a name="line.82"></a>
<FONT color="green">083</FONT>            public SimpleLongBitSet and(SimpleLongBitSet[] operands) {<a name="line.83"></a>
<FONT color="green">084</FONT>                return SimpleLongBitSet.getAnd(operands);<a name="line.84"></a>
<FONT color="green">085</FONT>            }<a name="line.85"></a>
<FONT color="green">086</FONT>            public SimpleLongBitSet or(SimpleLongBitSet opA, SimpleLongBitSet opB) {<a name="line.86"></a>
<FONT color="green">087</FONT>                return SimpleLongBitSet.getOr(opA, opB);<a name="line.87"></a>
<FONT color="green">088</FONT>            }<a name="line.88"></a>
<FONT color="green">089</FONT>        };<a name="line.89"></a>
<FONT color="green">090</FONT>        <a name="line.90"></a>
<FONT color="green">091</FONT>            private static final int BITS_PER_UNIT = 64;<a name="line.91"></a>
<FONT color="green">092</FONT>            private long[]  mUnits;<a name="line.92"></a>
<FONT color="green">093</FONT>    <a name="line.93"></a>
<FONT color="green">094</FONT>            public SimpleLongBitSet() {<a name="line.94"></a>
<FONT color="green">095</FONT>                    this(BITS_PER_UNIT);<a name="line.95"></a>
<FONT color="green">096</FONT>            }<a name="line.96"></a>
<FONT color="green">097</FONT>            public SimpleLongBitSet(int bitCapacity) {<a name="line.97"></a>
<FONT color="green">098</FONT>                    mUnits = new long[1 + (bitCapacity - 1) / BITS_PER_UNIT];<a name="line.98"></a>
<FONT color="green">099</FONT>            }<a name="line.99"></a>
<FONT color="green">100</FONT>        public SimpleLongBitSet(BitSet bitSet) {<a name="line.100"></a>
<FONT color="green">101</FONT>            this(bitSet.length());<a name="line.101"></a>
<FONT color="green">102</FONT>            for (int bit = bitSet.nextSetBit(0); bit &gt;= 0; bit = bitSet.nextSetBit(bit + 1)) {<a name="line.102"></a>
<FONT color="green">103</FONT>                set(bit);<a name="line.103"></a>
<FONT color="green">104</FONT>            }<a name="line.104"></a>
<FONT color="green">105</FONT>        }<a name="line.105"></a>
<FONT color="green">106</FONT>            public SimpleLongBitSet(GenericBitSet&lt;? extends GenericBitSet&gt; bitSet) {<a name="line.106"></a>
<FONT color="green">107</FONT>                    this(bitSet.length());<a name="line.107"></a>
<FONT color="green">108</FONT>                    for (int bit = bitSet.nextSetBit(0); bit &gt;= 0; bit = bitSet.nextSetBit(bit + 1)) {<a name="line.108"></a>
<FONT color="green">109</FONT>                            set(bit);<a name="line.109"></a>
<FONT color="green">110</FONT>                    }<a name="line.110"></a>
<FONT color="green">111</FONT>            }<a name="line.111"></a>
<FONT color="green">112</FONT>            public SimpleLongBitSet(String bitString) {<a name="line.112"></a>
<FONT color="green">113</FONT>                    this(bitString.length());<a name="line.113"></a>
<FONT color="green">114</FONT>                    for (int ii = 0; ii &lt; bitString.length(); ii++) {<a name="line.114"></a>
<FONT color="green">115</FONT>                            if (bitString.charAt(ii) == '1') set(ii);<a name="line.115"></a>
<FONT color="green">116</FONT>                    }<a name="line.116"></a>
<FONT color="green">117</FONT>            }<a name="line.117"></a>
<FONT color="green">118</FONT>            <a name="line.118"></a>
<FONT color="green">119</FONT>            public SimpleLongBitSet(long[] units, boolean cloneArray) {<a name="line.119"></a>
<FONT color="green">120</FONT>                    mUnits = cloneArray ? units.clone() : units;<a name="line.120"></a>
<FONT color="green">121</FONT>            }<a name="line.121"></a>
<FONT color="green">122</FONT>            <a name="line.122"></a>
<FONT color="green">123</FONT>            private void ensureCapacity(int unitLen) {<a name="line.123"></a>
<FONT color="green">124</FONT>                    if (mUnits.length &lt; unitLen) {<a name="line.124"></a>
<FONT color="green">125</FONT>                            long[] newUnits = new long[unitLen];<a name="line.125"></a>
<FONT color="green">126</FONT>                            System.arraycopy(mUnits, 0, newUnits, 0, mUnits.length);<a name="line.126"></a>
<FONT color="green">127</FONT>                            mUnits = newUnits;<a name="line.127"></a>
<FONT color="green">128</FONT>                    }<a name="line.128"></a>
<FONT color="green">129</FONT>            }<a name="line.129"></a>
<FONT color="green">130</FONT>    <a name="line.130"></a>
<FONT color="green">131</FONT>            public void set(int bit, boolean value) {<a name="line.131"></a>
<FONT color="green">132</FONT>                    if (value) set(bit); <a name="line.132"></a>
<FONT color="green">133</FONT>                    else clear(bit);<a name="line.133"></a>
<FONT color="green">134</FONT>            }<a name="line.134"></a>
<FONT color="green">135</FONT>            public void set(int bit) {<a name="line.135"></a>
<FONT color="green">136</FONT>                    int unit        = bit / BITS_PER_UNIT;<a name="line.136"></a>
<FONT color="green">137</FONT>                    int index       = bit % BITS_PER_UNIT;<a name="line.137"></a>
<FONT color="green">138</FONT>                    long mask       = 1L &lt;&lt; index;<a name="line.138"></a>
<FONT color="green">139</FONT>                    ensureCapacity(unit + 1);<a name="line.139"></a>
<FONT color="green">140</FONT>                    mUnits[unit] |= mask;<a name="line.140"></a>
<FONT color="green">141</FONT>            }<a name="line.141"></a>
<FONT color="green">142</FONT>    <a name="line.142"></a>
<FONT color="green">143</FONT>            public void clear(int bit) {<a name="line.143"></a>
<FONT color="green">144</FONT>                    int unit        = bit / BITS_PER_UNIT;<a name="line.144"></a>
<FONT color="green">145</FONT>                    int index       = bit % BITS_PER_UNIT;<a name="line.145"></a>
<FONT color="green">146</FONT>                    long mask       = 1L &lt;&lt; index;<a name="line.146"></a>
<FONT color="green">147</FONT>                    mUnits[unit] &amp;= ~mask;<a name="line.147"></a>
<FONT color="green">148</FONT>            }<a name="line.148"></a>
<FONT color="green">149</FONT>        <a name="line.149"></a>
<FONT color="green">150</FONT>        public void clear() {<a name="line.150"></a>
<FONT color="green">151</FONT>            for (int ii = 0; ii &lt; mUnits.length; ii++) {<a name="line.151"></a>
<FONT color="green">152</FONT>                mUnits[ii] = 0L;<a name="line.152"></a>
<FONT color="green">153</FONT>            }<a name="line.153"></a>
<FONT color="green">154</FONT>        }<a name="line.154"></a>
<FONT color="green">155</FONT>        <a name="line.155"></a>
<FONT color="green">156</FONT>        public void flip(int bit) {<a name="line.156"></a>
<FONT color="green">157</FONT>                    int unit        = bit / BITS_PER_UNIT;<a name="line.157"></a>
<FONT color="green">158</FONT>                    int index       = bit % BITS_PER_UNIT;<a name="line.158"></a>
<FONT color="green">159</FONT>                    long mask       = 1L &lt;&lt; index;<a name="line.159"></a>
<FONT color="green">160</FONT>                    ensureCapacity(unit + 1);<a name="line.160"></a>
<FONT color="green">161</FONT>                    mUnits[unit] ^= (mUnits[unit] &amp; mask);<a name="line.161"></a>
<FONT color="green">162</FONT>        }<a name="line.162"></a>
<FONT color="green">163</FONT>            <a name="line.163"></a>
<FONT color="green">164</FONT>            public boolean get(int bit) {<a name="line.164"></a>
<FONT color="green">165</FONT>                    int unit        = bit / BITS_PER_UNIT;<a name="line.165"></a>
<FONT color="green">166</FONT>                    if (unit &gt;= mUnits.length) return false;<a name="line.166"></a>
<FONT color="green">167</FONT>                    int index       = bit % BITS_PER_UNIT;<a name="line.167"></a>
<FONT color="green">168</FONT>                    long mask       = 1L &lt;&lt; index;<a name="line.168"></a>
<FONT color="green">169</FONT>                    return 0 != (mUnits[unit] &amp; mask);<a name="line.169"></a>
<FONT color="green">170</FONT>            }<a name="line.170"></a>
<FONT color="green">171</FONT>            <a name="line.171"></a>
<FONT color="green">172</FONT>            public boolean isSubSetOf(SimpleLongBitSet of) {<a name="line.172"></a>
<FONT color="green">173</FONT>            if (this == of) return true;<a name="line.173"></a>
<FONT color="green">174</FONT>    <a name="line.174"></a>
<FONT color="green">175</FONT>            int min = Math.min(mUnits.length, of.mUnits.length);<a name="line.175"></a>
<FONT color="green">176</FONT>                    for (int ii = 0; ii &lt; min; ii++) {<a name="line.176"></a>
<FONT color="green">177</FONT>                            //classical<a name="line.177"></a>
<FONT color="green">178</FONT>                            long and = mUnits[ii] &amp; of.mUnits[ii];<a name="line.178"></a>
<FONT color="green">179</FONT>                            if (and != mUnits[ii]) return false;<a name="line.179"></a>
<FONT color="green">180</FONT>                            <a name="line.180"></a>
<FONT color="green">181</FONT>                            //this -&gt; of == not this OR of<a name="line.181"></a>
<FONT color="green">182</FONT>    //                      if (-1L != (~mUnits[ii] | of.mUnits[ii])) return false;<a name="line.182"></a>
<FONT color="green">183</FONT>                            <a name="line.183"></a>
<FONT color="green">184</FONT>                            //not (this -&gt; of) == this AND not of<a name="line.184"></a>
<FONT color="green">185</FONT>    //                      if (0L != (mUnits[ii] &amp; ~of.mUnits[ii])) return false;<a name="line.185"></a>
<FONT color="green">186</FONT>                    }               <a name="line.186"></a>
<FONT color="green">187</FONT>                    for (int i = min; i &lt; mUnits.length; i++) {<a name="line.187"></a>
<FONT color="green">188</FONT>                            if (mUnits[i] != 0L) return false;<a name="line.188"></a>
<FONT color="green">189</FONT>                    }<a name="line.189"></a>
<FONT color="green">190</FONT>                    return true;<a name="line.190"></a>
<FONT color="green">191</FONT>            }<a name="line.191"></a>
<FONT color="green">192</FONT>            <a name="line.192"></a>
<FONT color="green">193</FONT>            public void and(SimpleLongBitSet with) {<a name="line.193"></a>
<FONT color="green">194</FONT>            if (this == with) return;<a name="line.194"></a>
<FONT color="green">195</FONT>    <a name="line.195"></a>
<FONT color="green">196</FONT>            int len = Math.min(mUnits.length, with.mUnits.length);<a name="line.196"></a>
<FONT color="green">197</FONT>                    for (int ii = 0; ii &lt; len; ii++) {<a name="line.197"></a>
<FONT color="green">198</FONT>                            mUnits[ii] &amp;= with.mUnits[ii];<a name="line.198"></a>
<FONT color="green">199</FONT>                    }<a name="line.199"></a>
<FONT color="green">200</FONT>                    for (int ii = len; ii &lt; mUnits.length; ii++) {<a name="line.200"></a>
<FONT color="green">201</FONT>                            mUnits[ii] = 0L;                        <a name="line.201"></a>
<FONT color="green">202</FONT>                    }<a name="line.202"></a>
<FONT color="green">203</FONT>            }<a name="line.203"></a>
<FONT color="green">204</FONT>            <a name="line.204"></a>
<FONT color="green">205</FONT>        public void or(SimpleLongBitSet with) {<a name="line.205"></a>
<FONT color="green">206</FONT>            if (this == with) return;<a name="line.206"></a>
<FONT color="green">207</FONT>            <a name="line.207"></a>
<FONT color="green">208</FONT>            if (with.mUnits.length &gt; mUnits.length) {<a name="line.208"></a>
<FONT color="green">209</FONT>                    long[] newUnits = new long[with.mUnits.length];<a name="line.209"></a>
<FONT color="green">210</FONT>                    for (int i = 0; i &lt; mUnits.length; i++) {<a name="line.210"></a>
<FONT color="green">211</FONT>                                    newUnits[i] = mUnits[i] | with.mUnits[i];<a name="line.211"></a>
<FONT color="green">212</FONT>                            }<a name="line.212"></a>
<FONT color="green">213</FONT>                    for (int i = mUnits.length; i &lt; with.mUnits.length; i++) {<a name="line.213"></a>
<FONT color="green">214</FONT>                                    newUnits[i] = with.mUnits[i];<a name="line.214"></a>
<FONT color="green">215</FONT>                            }<a name="line.215"></a>
<FONT color="green">216</FONT>                    mUnits = newUnits;<a name="line.216"></a>
<FONT color="green">217</FONT>            }<a name="line.217"></a>
<FONT color="green">218</FONT>            else {<a name="line.218"></a>
<FONT color="green">219</FONT>                    int len = Math.min(mUnits.length, with.mUnits.length);<a name="line.219"></a>
<FONT color="green">220</FONT>                    for (int i = 0; i &lt; len; i++) {<a name="line.220"></a>
<FONT color="green">221</FONT>                                    mUnits[i] |= with.mUnits[i];<a name="line.221"></a>
<FONT color="green">222</FONT>                            }<a name="line.222"></a>
<FONT color="green">223</FONT>            }<a name="line.223"></a>
<FONT color="green">224</FONT>        }<a name="line.224"></a>
<FONT color="green">225</FONT>        <a name="line.225"></a>
<FONT color="green">226</FONT>        /**<a name="line.226"></a>
<FONT color="green">227</FONT>         * This set becomes this ^ with<a name="line.227"></a>
<FONT color="green">228</FONT>         */<a name="line.228"></a>
<FONT color="green">229</FONT>        public void xor(SimpleLongBitSet with) {<a name="line.229"></a>
<FONT color="green">230</FONT>            int newlen = Math.max(mUnits.length, with.mUnits.length);<a name="line.230"></a>
<FONT color="green">231</FONT>            if (mUnits.length == with.mUnits.length) {<a name="line.231"></a>
<FONT color="green">232</FONT>                    while (newlen &gt; 0 &amp;&amp; 0L == (mUnits[newlen-1] ^ with.mUnits[newlen-1])) {<a name="line.232"></a>
<FONT color="green">233</FONT>                            newlen--;<a name="line.233"></a>
<FONT color="green">234</FONT>                    }<a name="line.234"></a>
<FONT color="green">235</FONT>            }<a name="line.235"></a>
<FONT color="green">236</FONT>            if (newlen != mUnits.length) {<a name="line.236"></a>
<FONT color="green">237</FONT>                    final long[] newUnits = new long[newlen];<a name="line.237"></a>
<FONT color="green">238</FONT>                    System.arraycopy(mUnits, 0, newUnits, 0, Math.min(newlen, mUnits.length));<a name="line.238"></a>
<FONT color="green">239</FONT>                    mUnits = newUnits;<a name="line.239"></a>
<FONT color="green">240</FONT>            }<a name="line.240"></a>
<FONT color="green">241</FONT>            final int len = Math.min(with.mUnits.length, newlen);<a name="line.241"></a>
<FONT color="green">242</FONT>                    for (int i = 0; i &lt; len; i++) {<a name="line.242"></a>
<FONT color="green">243</FONT>                            mUnits[i] ^= with.mUnits[i];<a name="line.243"></a>
<FONT color="green">244</FONT>                    }<a name="line.244"></a>
<FONT color="green">245</FONT>        }<a name="line.245"></a>
<FONT color="green">246</FONT>        <a name="line.246"></a>
<FONT color="green">247</FONT>        /**<a name="line.247"></a>
<FONT color="green">248</FONT>         * This set becomes this &amp; not with<a name="line.248"></a>
<FONT color="green">249</FONT>         */<a name="line.249"></a>
<FONT color="green">250</FONT>        public void andNot(SimpleLongBitSet with) {<a name="line.250"></a>
<FONT color="green">251</FONT>            //with is always true in the large parts, and thus always larger<a name="line.251"></a>
<FONT color="green">252</FONT>            //thus, this is always directing the new length<a name="line.252"></a>
<FONT color="green">253</FONT>            final int len = Math.min(mUnits.length, with.mUnits.length);<a name="line.253"></a>
<FONT color="green">254</FONT>            for (int i = 0; i &lt; len; i++) {<a name="line.254"></a>
<FONT color="green">255</FONT>                    mUnits[i] &amp;= ~with.mUnits[i];<a name="line.255"></a>
<FONT color="green">256</FONT>                    }<a name="line.256"></a>
<FONT color="green">257</FONT>            }<a name="line.257"></a>
<FONT color="green">258</FONT>    <a name="line.258"></a>
<FONT color="green">259</FONT>        public static SimpleLongBitSet getXor(SimpleLongBitSet setA, SimpleLongBitSet setB) {<a name="line.259"></a>
<FONT color="green">260</FONT>            final SimpleLongBitSet res;<a name="line.260"></a>
<FONT color="green">261</FONT>            if (setA.mUnits.length &gt; setB.mUnits.length) {<a name="line.261"></a>
<FONT color="green">262</FONT>                    res = setA.clone();<a name="line.262"></a>
<FONT color="green">263</FONT>                    res.xor(setB);<a name="line.263"></a>
<FONT color="green">264</FONT>            }<a name="line.264"></a>
<FONT color="green">265</FONT>            else {<a name="line.265"></a>
<FONT color="green">266</FONT>                    res = setB.clone();<a name="line.266"></a>
<FONT color="green">267</FONT>                    res.xor(setA);<a name="line.267"></a>
<FONT color="green">268</FONT>            }<a name="line.268"></a>
<FONT color="green">269</FONT>            return res;<a name="line.269"></a>
<FONT color="green">270</FONT>        }<a name="line.270"></a>
<FONT color="green">271</FONT>        /**<a name="line.271"></a>
<FONT color="green">272</FONT>         * Return the number of one bits in the xor of the two sets, that is, the<a name="line.272"></a>
<FONT color="green">273</FONT>         * number of bits which differ in the two sets<a name="line.273"></a>
<FONT color="green">274</FONT>         */<a name="line.274"></a>
<FONT color="green">275</FONT>        public static int getXorCardinality(SimpleLongBitSet setA, SimpleLongBitSet setB) {<a name="line.275"></a>
<FONT color="green">276</FONT>            int card = 0;<a name="line.276"></a>
<FONT color="green">277</FONT>            final int minLen = Math.min(setA.mUnits.length, setB.mUnits.length);<a name="line.277"></a>
<FONT color="green">278</FONT>            for (int i = 0; i &lt; minLen; i++) {<a name="line.278"></a>
<FONT color="green">279</FONT>                            card += IntegerUtil.bitCount(setA.mUnits[i] ^ setB.mUnits[i]);<a name="line.279"></a>
<FONT color="green">280</FONT>                    }<a name="line.280"></a>
<FONT color="green">281</FONT>            for (int i = minLen; i &lt; setA.mUnits.length; i++) {<a name="line.281"></a>
<FONT color="green">282</FONT>                            card += IntegerUtil.bitCount(setA.mUnits[i]);                   <a name="line.282"></a>
<FONT color="green">283</FONT>                    }<a name="line.283"></a>
<FONT color="green">284</FONT>            for (int i = minLen; i &lt; setB.mUnits.length; i++) {<a name="line.284"></a>
<FONT color="green">285</FONT>                            card += IntegerUtil.bitCount(setB.mUnits[i]);                   <a name="line.285"></a>
<FONT color="green">286</FONT>                    }<a name="line.286"></a>
<FONT color="green">287</FONT>            return card;<a name="line.287"></a>
<FONT color="green">288</FONT>        }<a name="line.288"></a>
<FONT color="green">289</FONT>        public static SimpleLongBitSet getOr(SimpleLongBitSet setA, SimpleLongBitSet setB) {<a name="line.289"></a>
<FONT color="green">290</FONT>            SimpleLongBitSet larger, smaller;<a name="line.290"></a>
<FONT color="green">291</FONT>            if (setA.mUnits.length &gt;= setB.mUnits.length) {<a name="line.291"></a>
<FONT color="green">292</FONT>                    larger  = setA;<a name="line.292"></a>
<FONT color="green">293</FONT>                    smaller = setB;<a name="line.293"></a>
<FONT color="green">294</FONT>            }<a name="line.294"></a>
<FONT color="green">295</FONT>            else {<a name="line.295"></a>
<FONT color="green">296</FONT>                    larger  = setB;<a name="line.296"></a>
<FONT color="green">297</FONT>                    smaller = setA;<a name="line.297"></a>
<FONT color="green">298</FONT>            }<a name="line.298"></a>
<FONT color="green">299</FONT>            long[] units = new long[larger.mUnits.length];<a name="line.299"></a>
<FONT color="green">300</FONT>            for (int i = 0; i &lt; smaller.mUnits.length; i++) {<a name="line.300"></a>
<FONT color="green">301</FONT>                            units[i] = smaller.mUnits[i] | larger.mUnits[i];<a name="line.301"></a>
<FONT color="green">302</FONT>                    }<a name="line.302"></a>
<FONT color="green">303</FONT>            return new SimpleLongBitSet(units, false);<a name="line.303"></a>
<FONT color="green">304</FONT>        }<a name="line.304"></a>
<FONT color="green">305</FONT>    <a name="line.305"></a>
<FONT color="green">306</FONT>        public static SimpleLongBitSet getAnd(SimpleLongBitSet setA, SimpleLongBitSet setB) {<a name="line.306"></a>
<FONT color="green">307</FONT>            SimpleLongBitSet larger, smaller;<a name="line.307"></a>
<FONT color="green">308</FONT>            if (setA.mUnits.length &gt;= setB.mUnits.length) {<a name="line.308"></a>
<FONT color="green">309</FONT>                    larger  = setA;<a name="line.309"></a>
<FONT color="green">310</FONT>                    smaller = setB;<a name="line.310"></a>
<FONT color="green">311</FONT>            }<a name="line.311"></a>
<FONT color="green">312</FONT>            else {<a name="line.312"></a>
<FONT color="green">313</FONT>                    larger  = setB;<a name="line.313"></a>
<FONT color="green">314</FONT>                    smaller = setA;<a name="line.314"></a>
<FONT color="green">315</FONT>            }<a name="line.315"></a>
<FONT color="green">316</FONT>            long[] units = new long[smaller.mUnits.length];<a name="line.316"></a>
<FONT color="green">317</FONT>            for (int i = 0; i &lt; smaller.mUnits.length; i++) {<a name="line.317"></a>
<FONT color="green">318</FONT>                            units[i] = smaller.mUnits[i] &amp; larger.mUnits[i];<a name="line.318"></a>
<FONT color="green">319</FONT>                    }<a name="line.319"></a>
<FONT color="green">320</FONT>            return new SimpleLongBitSet(units, false);<a name="line.320"></a>
<FONT color="green">321</FONT>            }<a name="line.321"></a>
<FONT color="green">322</FONT>        /**<a name="line.322"></a>
<FONT color="green">323</FONT>         * Returns setA and not setB<a name="line.323"></a>
<FONT color="green">324</FONT>         */<a name="line.324"></a>
<FONT color="green">325</FONT>        public static SimpleLongBitSet getAndNot(SimpleLongBitSet setA, SimpleLongBitSet setB) {<a name="line.325"></a>
<FONT color="green">326</FONT>            //set b is always true in the large parts, and thus always larger<a name="line.326"></a>
<FONT color="green">327</FONT>            //thus, set a is always directing the new length<a name="line.327"></a>
<FONT color="green">328</FONT>            final long[] units = new long[setA.mUnits.length];<a name="line.328"></a>
<FONT color="green">329</FONT>            for (int i = 0; i &lt; setB.mUnits.length; i++) {<a name="line.329"></a>
<FONT color="green">330</FONT>                            units[i] = setA.mUnits[i] &amp; ~setA.mUnits[i];<a name="line.330"></a>
<FONT color="green">331</FONT>                    }<a name="line.331"></a>
<FONT color="green">332</FONT>            for (int i = setB.mUnits.length; i &lt; setA.mUnits.length; i++) {<a name="line.332"></a>
<FONT color="green">333</FONT>                            units[i] = setA.mUnits[i];<a name="line.333"></a>
<FONT color="green">334</FONT>                    }<a name="line.334"></a>
<FONT color="green">335</FONT>            return new SimpleLongBitSet(units, false);<a name="line.335"></a>
<FONT color="green">336</FONT>            }<a name="line.336"></a>
<FONT color="green">337</FONT>            <a name="line.337"></a>
<FONT color="green">338</FONT>        public static SimpleLongBitSet getAnd(SimpleLongBitSet... bitSets) {<a name="line.338"></a>
<FONT color="green">339</FONT>            // handle special cases 0 - 2 sets<a name="line.339"></a>
<FONT color="green">340</FONT>            if (bitSets.length == 0) return new SimpleLongBitSet();<a name="line.340"></a>
<FONT color="green">341</FONT>            else if (bitSets.length == 1) return bitSets[0].clone();<a name="line.341"></a>
<FONT color="green">342</FONT>            else if (bitSets.length == 2) return getAnd(bitSets[0], bitSets[1]);<a name="line.342"></a>
<FONT color="green">343</FONT>            int smallest = 0;<a name="line.343"></a>
<FONT color="green">344</FONT>            for (int i = 1; i &lt; bitSets.length; i++) {<a name="line.344"></a>
<FONT color="green">345</FONT>                            if (bitSets[i].length() &lt; bitSets[smallest].length()) {<a name="line.345"></a>
<FONT color="green">346</FONT>                                    smallest = i;<a name="line.346"></a>
<FONT color="green">347</FONT>                            }<a name="line.347"></a>
<FONT color="green">348</FONT>                    }<a name="line.348"></a>
<FONT color="green">349</FONT>            final SimpleLongBitSet result = bitSets[smallest].clone();<a name="line.349"></a>
<FONT color="green">350</FONT>            for (int i = 0; i &lt; bitSets.length; i++) {<a name="line.350"></a>
<FONT color="green">351</FONT>                            if (i != smallest) result.and(bitSets[i]);<a name="line.351"></a>
<FONT color="green">352</FONT>                    }<a name="line.352"></a>
<FONT color="green">353</FONT>            return result;<a name="line.353"></a>
<FONT color="green">354</FONT>        }<a name="line.354"></a>
<FONT color="green">355</FONT>    <a name="line.355"></a>
<FONT color="green">356</FONT>        private int unitLength() {<a name="line.356"></a>
<FONT color="green">357</FONT>            int index = mUnits.length;<a name="line.357"></a>
<FONT color="green">358</FONT>            do index--;<a name="line.358"></a>
<FONT color="green">359</FONT>            while (index &gt;= 0 &amp;&amp; mUnits[index] == 0L);<a name="line.359"></a>
<FONT color="green">360</FONT>            return index + 1;<a name="line.360"></a>
<FONT color="green">361</FONT>            }<a name="line.361"></a>
<FONT color="green">362</FONT>        public int length() {<a name="line.362"></a>
<FONT color="green">363</FONT>            int index = mUnits.length;<a name="line.363"></a>
<FONT color="green">364</FONT>            do index--;<a name="line.364"></a>
<FONT color="green">365</FONT>            while (index &gt;= 0 &amp;&amp; mUnits[index] == 0L);<a name="line.365"></a>
<FONT color="green">366</FONT>            return index &lt; 0 ? 0 : index * BITS_PER_UNIT + bitLenL(mUnits[index]);<a name="line.366"></a>
<FONT color="green">367</FONT>            }<a name="line.367"></a>
<FONT color="green">368</FONT>        <a name="line.368"></a>
<FONT color="green">369</FONT>        private static int bitLenL(long l) {<a name="line.369"></a>
<FONT color="green">370</FONT>            int     high    = (int)(l &gt;&gt;&gt; 32);<a name="line.370"></a>
<FONT color="green">371</FONT>            int     low     = (int)l;        <a name="line.371"></a>
<FONT color="green">372</FONT>            return high == 0 ? bitLenI(low) : 32 + bitLenI(high);        <a name="line.372"></a>
<FONT color="green">373</FONT>        }<a name="line.373"></a>
<FONT color="green">374</FONT>            <a name="line.374"></a>
<FONT color="green">375</FONT>        /**<a name="line.375"></a>
<FONT color="green">376</FONT>         * copied from: java.util.BitSet<a name="line.376"></a>
<FONT color="green">377</FONT>         * bitLen(val) is the number of bits in val.<a name="line.377"></a>
<FONT color="green">378</FONT>         */<a name="line.378"></a>
<FONT color="green">379</FONT>        private static int bitLenI(int w) {<a name="line.379"></a>
<FONT color="green">380</FONT>            // Binary search - decision tree (5 tests, rarely 6)<a name="line.380"></a>
<FONT color="green">381</FONT>            return<a name="line.381"></a>
<FONT color="green">382</FONT>             (w &lt; 1&lt;&lt;15 ?<a name="line.382"></a>
<FONT color="green">383</FONT>              (w &lt; 1&lt;&lt;7 ?<a name="line.383"></a>
<FONT color="green">384</FONT>               (w &lt; 1&lt;&lt;3 ?<a name="line.384"></a>
<FONT color="green">385</FONT>                (w &lt; 1&lt;&lt;1 ? (w &lt; 1&lt;&lt;0 ? (w&lt;0 ? 32 : 0) : 1) : (w &lt; 1&lt;&lt;2 ? 2 : 3)) :<a name="line.385"></a>
<FONT color="green">386</FONT>                (w &lt; 1&lt;&lt;5 ? (w &lt; 1&lt;&lt;4 ? 4 : 5) : (w &lt; 1&lt;&lt;6 ? 6 : 7))) :<a name="line.386"></a>
<FONT color="green">387</FONT>               (w &lt; 1&lt;&lt;11 ?<a name="line.387"></a>
<FONT color="green">388</FONT>                (w &lt; 1&lt;&lt;9 ? (w &lt; 1&lt;&lt;8 ? 8 : 9) : (w &lt; 1&lt;&lt;10 ? 10 : 11)) :<a name="line.388"></a>
<FONT color="green">389</FONT>                (w &lt; 1&lt;&lt;13 ? (w &lt; 1&lt;&lt;12 ? 12 : 13) : (w &lt; 1&lt;&lt;14 ? 14 : 15)))) :<a name="line.389"></a>
<FONT color="green">390</FONT>              (w &lt; 1&lt;&lt;23 ?<a name="line.390"></a>
<FONT color="green">391</FONT>               (w &lt; 1&lt;&lt;19 ?<a name="line.391"></a>
<FONT color="green">392</FONT>                (w &lt; 1&lt;&lt;17 ? (w &lt; 1&lt;&lt;16 ? 16 : 17) : (w &lt; 1&lt;&lt;18 ? 18 : 19)) :<a name="line.392"></a>
<FONT color="green">393</FONT>                (w &lt; 1&lt;&lt;21 ? (w &lt; 1&lt;&lt;20 ? 20 : 21) : (w &lt; 1&lt;&lt;22 ? 22 : 23))) :<a name="line.393"></a>
<FONT color="green">394</FONT>               (w &lt; 1&lt;&lt;27 ?<a name="line.394"></a>
<FONT color="green">395</FONT>                (w &lt; 1&lt;&lt;25 ? (w &lt; 1&lt;&lt;24 ? 24 : 25) : (w &lt; 1&lt;&lt;26 ? 26 : 27)) :<a name="line.395"></a>
<FONT color="green">396</FONT>                (w &lt; 1&lt;&lt;29 ? (w &lt; 1&lt;&lt;28 ? 28 : 29) : (w &lt; 1&lt;&lt;30 ? 30 : 31)))));<a name="line.396"></a>
<FONT color="green">397</FONT>        }<a name="line.397"></a>
<FONT color="green">398</FONT>    <a name="line.398"></a>
<FONT color="green">399</FONT>        public boolean isEmpty() {<a name="line.399"></a>
<FONT color="green">400</FONT>            int index = mUnits.length;<a name="line.400"></a>
<FONT color="green">401</FONT>            do index--;<a name="line.401"></a>
<FONT color="green">402</FONT>            while (index &gt;= 0 &amp;&amp; mUnits[index] == 0L);<a name="line.402"></a>
<FONT color="green">403</FONT>            return index &lt; 0;<a name="line.403"></a>
<FONT color="green">404</FONT>            }<a name="line.404"></a>
<FONT color="green">405</FONT>            <a name="line.405"></a>
<FONT color="green">406</FONT>            @Override<a name="line.406"></a>
<FONT color="green">407</FONT>            public SimpleLongBitSet clone() {<a name="line.407"></a>
<FONT color="green">408</FONT>                    return new SimpleLongBitSet(mUnits.clone(), false);<a name="line.408"></a>
<FONT color="green">409</FONT>            }<a name="line.409"></a>
<FONT color="green">410</FONT>            <a name="line.410"></a>
<FONT color="green">411</FONT>            public int cardinality() {<a name="line.411"></a>
<FONT color="green">412</FONT>                    int card = 0;<a name="line.412"></a>
<FONT color="green">413</FONT>                    for (int ii = 0; ii &lt; mUnits.length; ii++) {<a name="line.413"></a>
<FONT color="green">414</FONT>                            //card += Long.bitCount(mUnits[ii]);<a name="line.414"></a>
<FONT color="green">415</FONT>                            card += IntegerUtil.bitCount(mUnits[ii]);<a name="line.415"></a>
<FONT color="green">416</FONT>                    }<a name="line.416"></a>
<FONT color="green">417</FONT>                    return card;<a name="line.417"></a>
<FONT color="green">418</FONT>            }<a name="line.418"></a>
<FONT color="green">419</FONT>            <a name="line.419"></a>
<FONT color="green">420</FONT>        public int cardinality(int fromBit, int toBit) {<a name="line.420"></a>
<FONT color="green">421</FONT>            int fromUnit    = fromBit / BITS_PER_UNIT;<a name="line.421"></a>
<FONT color="green">422</FONT>            int toUnit      = (toBit + BITS_PER_UNIT - 1) / BITS_PER_UNIT;<a name="line.422"></a>
<FONT color="green">423</FONT>            int unitStart   = Math.max(0, fromUnit);<a name="line.423"></a>
<FONT color="green">424</FONT>            int unitLen     = Math.min(mUnits.length, toUnit);<a name="line.424"></a>
<FONT color="green">425</FONT>            int card = 0;<a name="line.425"></a>
<FONT color="green">426</FONT>            for (int ii = unitStart; ii &lt; unitLen; ii++) {<a name="line.426"></a>
<FONT color="green">427</FONT>                if (mUnits[ii] != 0) {<a name="line.427"></a>
<FONT color="green">428</FONT>                    long unit = mUnits[ii];<a name="line.428"></a>
<FONT color="green">429</FONT>                    if (ii == fromUnit) {<a name="line.429"></a>
<FONT color="green">430</FONT>                        int bit = fromBit % BITS_PER_UNIT;<a name="line.430"></a>
<FONT color="green">431</FONT>                        unit &amp;= (0xffffffffffffffffL &gt;&gt;&gt; bit);<a name="line.431"></a>
<FONT color="green">432</FONT>                    }<a name="line.432"></a>
<FONT color="green">433</FONT>                    if (ii == toUnit - 1) {<a name="line.433"></a>
<FONT color="green">434</FONT>                        int bit = fromBit % BITS_PER_UNIT;<a name="line.434"></a>
<FONT color="green">435</FONT>                        unit &amp;= (0xffffffffffffffffL &lt;&lt; (BITS_PER_UNIT - bit));<a name="line.435"></a>
<FONT color="green">436</FONT>                    }<a name="line.436"></a>
<FONT color="green">437</FONT>                    card += Long.bitCount(unit);<a name="line.437"></a>
<FONT color="green">438</FONT>                }<a name="line.438"></a>
<FONT color="green">439</FONT>            }<a name="line.439"></a>
<FONT color="green">440</FONT>            return card;<a name="line.440"></a>
<FONT color="green">441</FONT>        }<a name="line.441"></a>
<FONT color="green">442</FONT>            <a name="line.442"></a>
<FONT color="green">443</FONT>        @Override<a name="line.443"></a>
<FONT color="green">444</FONT>        public int hashCode() {<a name="line.444"></a>
<FONT color="green">445</FONT>            int code = 0;<a name="line.445"></a>
<FONT color="green">446</FONT>            for (int ii = 0; ii &lt; mUnits.length; ii++) {<a name="line.446"></a>
<FONT color="green">447</FONT>                code ^= (0x00000000ffffffffL &amp; mUnits[ii]);<a name="line.447"></a>
<FONT color="green">448</FONT>                code ^= (0x00000000ffffffffL &amp; (mUnits[ii] &gt;&gt;&gt; 32));<a name="line.448"></a>
<FONT color="green">449</FONT>            }<a name="line.449"></a>
<FONT color="green">450</FONT>            return code;<a name="line.450"></a>
<FONT color="green">451</FONT>        }<a name="line.451"></a>
<FONT color="green">452</FONT>        <a name="line.452"></a>
<FONT color="green">453</FONT>        public int hashCodeObj() {<a name="line.453"></a>
<FONT color="green">454</FONT>            return super.hashCode();<a name="line.454"></a>
<FONT color="green">455</FONT>        }<a name="line.455"></a>
<FONT color="green">456</FONT>    <a name="line.456"></a>
<FONT color="green">457</FONT>        @Override<a name="line.457"></a>
<FONT color="green">458</FONT>        public boolean equals(Object obj) {<a name="line.458"></a>
<FONT color="green">459</FONT>            if (obj == this) return true;<a name="line.459"></a>
<FONT color="green">460</FONT>            if (obj instanceof SimpleLongBitSet) {<a name="line.460"></a>
<FONT color="green">461</FONT>                SimpleLongBitSet bitSet = (SimpleLongBitSet)obj;<a name="line.461"></a>
<FONT color="green">462</FONT>                int len = Math.min(mUnits.length, bitSet.mUnits.length);<a name="line.462"></a>
<FONT color="green">463</FONT>                for (int ii = 0; ii &lt; len; ii++) {<a name="line.463"></a>
<FONT color="green">464</FONT>                    if (mUnits[ii] != bitSet.mUnits[ii]) return false;<a name="line.464"></a>
<FONT color="green">465</FONT>                }<a name="line.465"></a>
<FONT color="green">466</FONT>                for (int ii = len; ii &lt; mUnits.length; ii++) {<a name="line.466"></a>
<FONT color="green">467</FONT>                                    if (mUnits[ii] != 0L) return false;<a name="line.467"></a>
<FONT color="green">468</FONT>                            }<a name="line.468"></a>
<FONT color="green">469</FONT>                for (int ii = len; ii &lt; bitSet.mUnits.length; ii++) {<a name="line.469"></a>
<FONT color="green">470</FONT>                                    if (bitSet.mUnits[ii] != 0L) return false;<a name="line.470"></a>
<FONT color="green">471</FONT>                            }<a name="line.471"></a>
<FONT color="green">472</FONT>                return true;<a name="line.472"></a>
<FONT color="green">473</FONT>            }<a name="line.473"></a>
<FONT color="green">474</FONT>            return false;<a name="line.474"></a>
<FONT color="green">475</FONT>        }<a name="line.475"></a>
<FONT color="green">476</FONT>        <a name="line.476"></a>
<FONT color="green">477</FONT>        @Override<a name="line.477"></a>
<FONT color="green">478</FONT>        public String toString() {<a name="line.478"></a>
<FONT color="green">479</FONT>            StringBuilder sb = new StringBuilder();<a name="line.479"></a>
<FONT color="green">480</FONT>            sb.append('{');<a name="line.480"></a>
<FONT color="green">481</FONT>            int unitLen = unitLength();<a name="line.481"></a>
<FONT color="green">482</FONT>            for (int ii = 0; ii &lt; unitLen; ii++) {<a name="line.482"></a>
<FONT color="green">483</FONT>                    int len = ii == unitLen - 1 ? 1 + (length() - 1) % BITS_PER_UNIT : BITS_PER_UNIT;<a name="line.483"></a>
<FONT color="green">484</FONT>                if (mUnits[ii] != 0) {<a name="line.484"></a>
<FONT color="green">485</FONT>                    long bit = 1L;<a name="line.485"></a>
<FONT color="green">486</FONT>                    for (int jj = 0; jj &lt; len; jj++, bit &lt;&lt;= 1) {<a name="line.486"></a>
<FONT color="green">487</FONT>                                            if ((mUnits[ii] &amp; bit) != 0) sb.append('1');<a name="line.487"></a>
<FONT color="green">488</FONT>                                            else sb.append('0');<a name="line.488"></a>
<FONT color="green">489</FONT>                                    }<a name="line.489"></a>
<FONT color="green">490</FONT>                }<a name="line.490"></a>
<FONT color="green">491</FONT>                else {<a name="line.491"></a>
<FONT color="green">492</FONT>                    sb.append("0000000000000000000000000000000000000000000000000000000000000000", 0, len);<a name="line.492"></a>
<FONT color="green">493</FONT>                }<a name="line.493"></a>
<FONT color="green">494</FONT>            }<a name="line.494"></a>
<FONT color="green">495</FONT>            sb.append('}');<a name="line.495"></a>
<FONT color="green">496</FONT>            return sb.toString();<a name="line.496"></a>
<FONT color="green">497</FONT>        }<a name="line.497"></a>
<FONT color="green">498</FONT>        <a name="line.498"></a>
<FONT color="green">499</FONT>        public int nextSetBit(int from) {<a name="line.499"></a>
<FONT color="green">500</FONT>            int fromBit     = from % BITS_PER_UNIT;<a name="line.500"></a>
<FONT color="green">501</FONT>            int fromUnit    = from / BITS_PER_UNIT;<a name="line.501"></a>
<FONT color="green">502</FONT>            for (int ii = Math.max(0, fromUnit); ii &lt; mUnits.length; ii++) {<a name="line.502"></a>
<FONT color="green">503</FONT>                if (mUnits[ii] != 0L) {<a name="line.503"></a>
<FONT color="green">504</FONT>                    long unit = mUnits[ii];<a name="line.504"></a>
<FONT color="green">505</FONT>                    if (ii == fromUnit) unit &amp;= (0xffffffffffffffffL &lt;&lt; fromBit);<a name="line.505"></a>
<FONT color="green">506</FONT>                    if (unit != 0L) return ii * BITS_PER_UNIT + Long.numberOfTrailingZeros(unit);<a name="line.506"></a>
<FONT color="green">507</FONT>                }<a name="line.507"></a>
<FONT color="green">508</FONT>            }<a name="line.508"></a>
<FONT color="green">509</FONT>            return -1;        <a name="line.509"></a>
<FONT color="green">510</FONT>        }<a name="line.510"></a>
<FONT color="green">511</FONT>        <a name="line.511"></a>
<FONT color="green">512</FONT>        public int nextClearBit(int from) {<a name="line.512"></a>
<FONT color="green">513</FONT>            int fromBit     = from % BITS_PER_UNIT;<a name="line.513"></a>
<FONT color="green">514</FONT>            int fromUnit    = from / BITS_PER_UNIT;<a name="line.514"></a>
<FONT color="green">515</FONT>            for (int ii = fromUnit; ii &lt; mUnits.length; ii++) {<a name="line.515"></a>
<FONT color="green">516</FONT>                if (mUnits[ii] != -1L) {<a name="line.516"></a>
<FONT color="green">517</FONT>                    long unit = ~mUnits[ii];<a name="line.517"></a>
<FONT color="green">518</FONT>                    if (ii == fromUnit) unit &amp;= (0xffffffffffffffffL &lt;&lt; fromBit);<a name="line.518"></a>
<FONT color="green">519</FONT>                    if (unit != 0) return ii * BITS_PER_UNIT + Long.numberOfTrailingZeros(unit);<a name="line.519"></a>
<FONT color="green">520</FONT>                }<a name="line.520"></a>
<FONT color="green">521</FONT>            }<a name="line.521"></a>
<FONT color="green">522</FONT>            return Math.max(from, length());        <a name="line.522"></a>
<FONT color="green">523</FONT>        }<a name="line.523"></a>
<FONT color="green">524</FONT>        <a name="line.524"></a>
<FONT color="green">525</FONT>        public BitSet toBitSet() {<a name="line.525"></a>
<FONT color="green">526</FONT>            BitSet bitSet = new BitSet(length());<a name="line.526"></a>
<FONT color="green">527</FONT>            for (int bit = nextSetBit(0); bit &gt;= 0; bit = nextSetBit(bit + 1)) {<a name="line.527"></a>
<FONT color="green">528</FONT>                bitSet.set(bit);<a name="line.528"></a>
<FONT color="green">529</FONT>            }<a name="line.529"></a>
<FONT color="green">530</FONT>            return bitSet;<a name="line.530"></a>
<FONT color="green">531</FONT>        }<a name="line.531"></a>
<FONT color="green">532</FONT>        <a name="line.532"></a>
<FONT color="green">533</FONT>        public void writeTo(OutputStream out) throws IOException {<a name="line.533"></a>
<FONT color="green">534</FONT>            final DataOutput dout = out instanceof DataOutput ?<a name="line.534"></a>
<FONT color="green">535</FONT>                    (DataOutput)out : new DataOutputStream(out);<a name="line.535"></a>
<FONT color="green">536</FONT>            dout.writeInt(mUnits.length);<a name="line.536"></a>
<FONT color="green">537</FONT>            for (int i = 0; i &lt; mUnits.length; i++) {<a name="line.537"></a>
<FONT color="green">538</FONT>                dout.writeLong(mUnits[i]);<a name="line.538"></a>
<FONT color="green">539</FONT>            }<a name="line.539"></a>
<FONT color="green">540</FONT>        }<a name="line.540"></a>
<FONT color="green">541</FONT>        <a name="line.541"></a>
<FONT color="green">542</FONT>        public static SimpleLongBitSet readFrom(InputStream in) throws IOException {<a name="line.542"></a>
<FONT color="green">543</FONT>            final DataInput din = in instanceof DataInput ? <a name="line.543"></a>
<FONT color="green">544</FONT>                    (DataInput)in : new DataInputStream(in);<a name="line.544"></a>
<FONT color="green">545</FONT>            final int len = din.readInt();<a name="line.545"></a>
<FONT color="green">546</FONT>            final long[] units = new long[len];<a name="line.546"></a>
<FONT color="green">547</FONT>            for (int i = 0; i &lt; len; i++) {<a name="line.547"></a>
<FONT color="green">548</FONT>                units[i] = din.readLong();<a name="line.548"></a>
<FONT color="green">549</FONT>            }<a name="line.549"></a>
<FONT color="green">550</FONT>            return new SimpleLongBitSet(units, false /*clone*/);<a name="line.550"></a>
<FONT color="green">551</FONT>        }<a name="line.551"></a>
<FONT color="green">552</FONT>        <a name="line.552"></a>
<FONT color="green">553</FONT>        public byte[] compress() {<a name="line.553"></a>
<FONT color="green">554</FONT>            ByteArrayOutputStream out = new ByteArrayOutputStream();<a name="line.554"></a>
<FONT color="green">555</FONT>            try {<a name="line.555"></a>
<FONT color="green">556</FONT>                compress(out);<a name="line.556"></a>
<FONT color="green">557</FONT>            }<a name="line.557"></a>
<FONT color="green">558</FONT>            catch (IOException ex) {<a name="line.558"></a>
<FONT color="green">559</FONT>                throw new RuntimeException(ex);<a name="line.559"></a>
<FONT color="green">560</FONT>            }<a name="line.560"></a>
<FONT color="green">561</FONT>            return out.toByteArray();<a name="line.561"></a>
<FONT color="green">562</FONT>        }<a name="line.562"></a>
<FONT color="green">563</FONT>        <a name="line.563"></a>
<FONT color="green">564</FONT>        public void compress(OutputStream out) throws IOException {<a name="line.564"></a>
<FONT color="green">565</FONT>            ZipOutputStream zOut    = new ZipOutputStream(out);<a name="line.565"></a>
<FONT color="green">566</FONT>            //zOut.setLevel(Deflater.BEST_SPEED);<a name="line.566"></a>
<FONT color="green">567</FONT>            zOut.putNextEntry(new ZipEntry("A"));<a name="line.567"></a>
<FONT color="green">568</FONT>            DataOutputStream dOut   = new DataOutputStream(zOut);<a name="line.568"></a>
<FONT color="green">569</FONT>            dOut.writeInt(mUnits.length);<a name="line.569"></a>
<FONT color="green">570</FONT>            for (int ii = 0; ii &lt; mUnits.length; ii++) {<a name="line.570"></a>
<FONT color="green">571</FONT>                dOut.writeLong(mUnits[ii]);<a name="line.571"></a>
<FONT color="green">572</FONT>            }        <a name="line.572"></a>
<FONT color="green">573</FONT>            dOut.flush();<a name="line.573"></a>
<FONT color="green">574</FONT>            zOut.closeEntry();<a name="line.574"></a>
<FONT color="green">575</FONT>            zOut.flush();<a name="line.575"></a>
<FONT color="green">576</FONT>        }<a name="line.576"></a>
<FONT color="green">577</FONT>        <a name="line.577"></a>
<FONT color="green">578</FONT>        public static SimpleLongBitSet uncompress(byte[] bytes) {<a name="line.578"></a>
<FONT color="green">579</FONT>            ByteArrayInputStream byteIn = new ByteArrayInputStream(bytes);<a name="line.579"></a>
<FONT color="green">580</FONT>            try {<a name="line.580"></a>
<FONT color="green">581</FONT>                return uncompress(byteIn);            <a name="line.581"></a>
<FONT color="green">582</FONT>            }<a name="line.582"></a>
<FONT color="green">583</FONT>            catch (IOException ioe) {<a name="line.583"></a>
<FONT color="green">584</FONT>                throw new RuntimeException(ioe);<a name="line.584"></a>
<FONT color="green">585</FONT>            }<a name="line.585"></a>
<FONT color="green">586</FONT>        }<a name="line.586"></a>
<FONT color="green">587</FONT>        <a name="line.587"></a>
<FONT color="green">588</FONT>        public static SimpleLongBitSet uncompress(InputStream in) throws IOException {<a name="line.588"></a>
<FONT color="green">589</FONT>            ZipInputStream zIn  = new ZipInputStream(in);<a name="line.589"></a>
<FONT color="green">590</FONT>            zIn.getNextEntry();<a name="line.590"></a>
<FONT color="green">591</FONT>            DataInputStream dIn = new DataInputStream(zIn);<a name="line.591"></a>
<FONT color="green">592</FONT>            int unitLen    = dIn.readInt();<a name="line.592"></a>
<FONT color="green">593</FONT>            long[] units   = new long[unitLen];<a name="line.593"></a>
<FONT color="green">594</FONT>            for (int ii = 0; ii &lt; unitLen; ii++) {<a name="line.594"></a>
<FONT color="green">595</FONT>                units[ii] = dIn.readLong();<a name="line.595"></a>
<FONT color="green">596</FONT>            }<a name="line.596"></a>
<FONT color="green">597</FONT>            return new SimpleLongBitSet(units, false);<a name="line.597"></a>
<FONT color="green">598</FONT>        }<a name="line.598"></a>
<FONT color="green">599</FONT>        <a name="line.599"></a>
<FONT color="green">600</FONT>        public BitSetFactory&lt;SimpleLongBitSet&gt; factory() {<a name="line.600"></a>
<FONT color="green">601</FONT>            return FACTORY;<a name="line.601"></a>
<FONT color="green">602</FONT>        }<a name="line.602"></a>
<FONT color="green">603</FONT>        <a name="line.603"></a>
<FONT color="green">604</FONT>        public BitSetOps&lt;SimpleLongBitSet&gt; ops() {<a name="line.604"></a>
<FONT color="green">605</FONT>            return OPS;<a name="line.605"></a>
<FONT color="green">606</FONT>        }<a name="line.606"></a>
<FONT color="green">607</FONT>        <a name="line.607"></a>
<FONT color="green">608</FONT>        public long[] toLongArray() {<a name="line.608"></a>
<FONT color="green">609</FONT>            return toLongArray(null, 0);<a name="line.609"></a>
<FONT color="green">610</FONT>        }<a name="line.610"></a>
<FONT color="green">611</FONT>        <a name="line.611"></a>
<FONT color="green">612</FONT>        public long[] toLongArray(long[] arr, int offset) {<a name="line.612"></a>
<FONT color="green">613</FONT>            int len = unitLength();<a name="line.613"></a>
<FONT color="green">614</FONT>            if (arr == null || arr.length &lt; len + offset) {<a name="line.614"></a>
<FONT color="green">615</FONT>                arr = new long[len + offset];<a name="line.615"></a>
<FONT color="green">616</FONT>            }<a name="line.616"></a>
<FONT color="green">617</FONT>            System.arraycopy(mUnits, 0, arr, offset, len);   <a name="line.617"></a>
<FONT color="green">618</FONT>            return arr;<a name="line.618"></a>
<FONT color="green">619</FONT>        }<a name="line.619"></a>
<FONT color="green">620</FONT>        <a name="line.620"></a>
<FONT color="green">621</FONT>        public static void main(String[] args) {<a name="line.621"></a>
<FONT color="green">622</FONT>    //      System.out.println(new SimpleLongBitSet("00001111").nextClearBit(0));<a name="line.622"></a>
<FONT color="green">623</FONT>    //      System.out.println(new SimpleLongBitSet("00001111").nextClearBit(1));<a name="line.623"></a>
<FONT color="green">624</FONT>    //      System.out.println(new SimpleLongBitSet("00001111").nextClearBit(2));<a name="line.624"></a>
<FONT color="green">625</FONT>    //      System.out.println(new SimpleLongBitSet("00001111").nextClearBit(3));<a name="line.625"></a>
<FONT color="green">626</FONT>    //      System.out.println(new SimpleLongBitSet("00001111").nextClearBit(4));<a name="line.626"></a>
<FONT color="green">627</FONT>    //<a name="line.627"></a>
<FONT color="green">628</FONT>    //      System.out.println(new SimpleLongBitSet("00001111").nextSetBit(0));<a name="line.628"></a>
<FONT color="green">629</FONT>    //      System.out.println(new SimpleLongBitSet("00001111").nextSetBit(1));<a name="line.629"></a>
<FONT color="green">630</FONT>    //      System.out.println(new SimpleLongBitSet("00001111").nextSetBit(2));<a name="line.630"></a>
<FONT color="green">631</FONT>    //      System.out.println(new SimpleLongBitSet("00001111").nextSetBit(3));<a name="line.631"></a>
<FONT color="green">632</FONT>    //      System.out.println(new SimpleLongBitSet("00001111").nextSetBit(4));<a name="line.632"></a>
<FONT color="green">633</FONT>    //      System.out.println(new SimpleLongBitSet("00001111").nextSetBit(7));<a name="line.633"></a>
<FONT color="green">634</FONT>    //      System.out.println(new SimpleLongBitSet("00001111").nextSetBit(8));<a name="line.634"></a>
<FONT color="green">635</FONT>    //      if (true) return;<a name="line.635"></a>
<FONT color="green">636</FONT>            Random rnd = new Random();<a name="line.636"></a>
<FONT color="green">637</FONT>            SimpleLongBitSet set = new SimpleLongBitSet("10000000000000000000000000000000000000000000000000000000000000011000000000000000000000000000000000000000000000000000000000000001");<a name="line.637"></a>
<FONT color="green">638</FONT>            System.out.println(set.length() + "/" + set.cardinality());<a name="line.638"></a>
<FONT color="green">639</FONT>            System.out.println("uncompressed: " + set.mUnits.length * 8 + 2 * 4);<a name="line.639"></a>
<FONT color="green">640</FONT>            System.out.println("compressed: " + set.compress().length);<a name="line.640"></a>
<FONT color="green">641</FONT>            System.out.println(set);<a name="line.641"></a>
<FONT color="green">642</FONT>            System.out.println(SimpleLongBitSet.uncompress(set.compress()));<a name="line.642"></a>
<FONT color="green">643</FONT>            final int cnt = 32;<a name="line.643"></a>
<FONT color="green">644</FONT>            for (int ii = 0; ii &lt; cnt; ii++) {<a name="line.644"></a>
<FONT color="green">645</FONT>                if (rnd.nextInt(5) &lt;= 3) set.set(ii);<a name="line.645"></a>
<FONT color="green">646</FONT>            }<a name="line.646"></a>
<FONT color="green">647</FONT>            System.out.println(set.length() + "/" + set.cardinality());<a name="line.647"></a>
<FONT color="green">648</FONT>            System.out.println("uncompressed: " + set.mUnits.length * 8 + 2 * 4);<a name="line.648"></a>
<FONT color="green">649</FONT>            System.out.println("compressed: " + set.compress().length);<a name="line.649"></a>
<FONT color="green">650</FONT>            System.out.println(set.equals(SimpleLongBitSet.uncompress(set.compress())));<a name="line.650"></a>
<FONT color="green">651</FONT>            /*<a name="line.651"></a>
<FONT color="green">652</FONT>            System.out.println(new SimpleLongBitSet("01010101010101010101"));<a name="line.652"></a>
<FONT color="green">653</FONT>            System.out.println(new SimpleLongBitSet("11111111000000001111000000001111"));<a name="line.653"></a>
<FONT color="green">654</FONT>            System.out.println(new SimpleLongBitSet("1111111100000000111100000000111111111111000000001111000000001111"));<a name="line.654"></a>
<FONT color="green">655</FONT>            System.out.println(SimpleLongBitSet.getAnd(new SimpleLongBitSet("111100001111"), new SimpleLongBitSet("110011110101")));<a name="line.655"></a>
<FONT color="green">656</FONT>            System.out.println(SimpleLongBitSet.getAnd(new SimpleLongBitSet("111100001111111100001111111100001111111100001111111100001111111100001111111100001111111100001111111100001111111100001111111100001111111100001111"), new SimpleLongBitSet("110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101110011110101")));<a name="line.656"></a>
<FONT color="green">657</FONT>            SimpleLongBitSet set = new SimpleLongBitSet("1111111100000000111100000000111111111111000000001111000000001111");<a name="line.657"></a>
<FONT color="green">658</FONT>            set.clear(3);<a name="line.658"></a>
<FONT color="green">659</FONT>            System.out.println(set);<a name="line.659"></a>
<FONT color="green">660</FONT>            set.clear(0);<a name="line.660"></a>
<FONT color="green">661</FONT>            System.out.println(set);<a name="line.661"></a>
<FONT color="green">662</FONT>            set = new SimpleLongBitSet("10000000000000000000000000000000000000000000000000000000000000011000000000000000000000000000000000000000000000000000000000000001");<a name="line.662"></a>
<FONT color="green">663</FONT>            System.out.println(set);<a name="line.663"></a>
<FONT color="green">664</FONT>            set.clear(63);<a name="line.664"></a>
<FONT color="green">665</FONT>            System.out.println(set);<a name="line.665"></a>
<FONT color="green">666</FONT>            set.clear(64);<a name="line.666"></a>
<FONT color="green">667</FONT>            System.out.println(set);<a name="line.667"></a>
<FONT color="green">668</FONT>            set.clear(127);<a name="line.668"></a>
<FONT color="green">669</FONT>            System.out.println(set);<a name="line.669"></a>
<FONT color="green">670</FONT>            set.clear(0);<a name="line.670"></a>
<FONT color="green">671</FONT>            System.out.println(set);<a name="line.671"></a>
<FONT color="green">672</FONT>            set.set(63);<a name="line.672"></a>
<FONT color="green">673</FONT>            System.out.println(set);<a name="line.673"></a>
<FONT color="green">674</FONT>            set.set(64);<a name="line.674"></a>
<FONT color="green">675</FONT>            System.out.println(set);<a name="line.675"></a>
<FONT color="green">676</FONT>            set.set(127);<a name="line.676"></a>
<FONT color="green">677</FONT>            System.out.println(set);<a name="line.677"></a>
<FONT color="green">678</FONT>            set.set(0);<a name="line.678"></a>
<FONT color="green">679</FONT>            System.out.println(set);<a name="line.679"></a>
<FONT color="green">680</FONT>            */<a name="line.680"></a>
<FONT color="green">681</FONT>            //System.out.println(SimpleLongBitSet.getAnd(new SimpleLongBitSet[] {new SimpleLongBitSet("111100001111"), new SimpleLongBitSet("110011110101"), new SimpleLongBitSet("111100001111"), new SimpleLongBitSet("110011110101")}));<a name="line.681"></a>
<FONT color="green">682</FONT>        }<a name="line.682"></a>
<FONT color="green">683</FONT>    <a name="line.683"></a>
<FONT color="green">684</FONT>    }<a name="line.684"></a>




























































</PRE>
</BODY>
</HTML>
